

#include "Appevent.ch"
#include "Xbp.ch"
#include "Gra.ch"
#include "Font.ch"
#include "color.ch"
#include "common.ch"
#include "dcdialog.ch" // eXPress++
#include "dcgra.ch"    // eXPress++
#include "TEST1.CH"

PROCEDURE APPSYS()
RETURN

PROCEDURE MAIN()
     SET CHARSET TO ANSI             // ANSI FONT
     SET DATE FORMAT TO "dd.mm.yyyy" // set date german and serbian
     DC_DotHotKey(180)               // Prebaci DotPrompt sa Alt+D na ...
     SetCancel(.F.)                  // turn off Alt+C

     TEST()
RETURN




*****************
PROCEDURE TEST()
*****************
LOCAL GetList := {}, GetOptions , oDlg

//-------------------------- naslov

@ 5,2  DCPUSHBUTTON CAPTION "101"  SIZE 6,1
@ 5,12 DCPUSHBUTTON CAPTION "102" SIZE 6,1

@ 5,22 DCPUSHBUTTON CAPTION "BMP" SIZE 6,1
@ 5,32 DCPUSHBUTTON CAPTION "GIF" SIZE 6,1
@ 5,42 DCPUSHBUTTON CAPTION "JPG" SIZE 6,1
@ 5,52 DCPUSHBUTTON CAPTION "PNG" SIZE 6,1

//-------------------------- ukljuivanje transparencije za bitmape

aColor := { 192, 192, 192 }          // RGB boja koja se prevodi u transparentnu
DC_BitmapTransparentColor( aColor )  // eXPress++ komanda

//-------------------------- uitavanje bitmape iz EXE i BMPFiles Xbase++ komande

    * EXEPICTURE je mnemonik iz TEST1.CH fajla,
    * za resurs RACUN.BMP uitan iz EXE fajla kao ID = 101
    * umesto EXEPICTURE moe se koristiti i numerik 101

    * DLLPICTURE je mnemonik iz TEST1.CH fajla,
    * za resurs RACUN.BMP uitan iz DLL fajla kao ID = 10001
    * umesto DLLPICTURE moe se koristiti i numerik 10001

      BMPRACUN := XbpBitmap():new():create()
      BMPRACUN:load( NIL, 102 )

    * BMPRACUN je resurs RACUN.BMP uitan iz EXE fajla kao OBJEKAT

      BMP_RACUN := XbpBitmap():new():create()
      BMP_RACUN:LoadFile("RACUN.BMP")

      GIF_RACUN := XbpBitmap():new():create()
      GIF_RACUN:LoadFile("RACUN.GIF")

      JPG_RACUN := XbpBitmap():new():create()
      JPG_RACUN:LoadFile("RACUN.JPG")

      PNG_RACUN := XbpBitmap():new():create()
      PNG_RACUN:LoadFile("RACUN.PNG")

//-------------------------- opis korienih komandi

@ 7,2  DCSAY 'DC_BitmapTransparentColor( {192,192,192} )  'SAYSIZE 0
@ 8,2  DCSAY 'nBMP := 101 ili EXEPICTURE * resurs je numerik iz test.ch'       SAYSIZE 0
@ 9,2  DCSAY 'oBMP := XbpBitmap():new():create(); oBMP:load( NIL, 102 )'       SAYSIZE 0
@ 10,2 DCSAY 'oBMP := XbpBitmap():new():create(); oBMP:loadFile( "racun.bmp" )'SAYSIZE 0

//-------------------------- prikaz rezultata

@ 11,2  DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION EXEPICTURE
@ 11,12 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMPRACUN
@ 11,22 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP_RACUN
@ 11,32 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION GIF_RACUN
@ 11,42 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION JPG_RACUN
@ 11,52 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION PNG_RACUN

@ 14,2  DCPUSHBUTTON CAPTION EXEPICTURE SIZE 6,2.5
@ 14,12 DCPUSHBUTTON CAPTION BMPRACUN SIZE 6,2.5
@ 14,22 DCPUSHBUTTON CAPTION BMP_RACUN SIZE 6,2.5
@ 14,32 DCPUSHBUTTON CAPTION GIF_RACUN SIZE 6,2.5
@ 14,42 DCPUSHBUTTON CAPTION JPG_RACUN SIZE 6,2.5
@ 14,52 DCPUSHBUTTON CAPTION PNG_RACUN SIZE 6,2.5

//-------------------------- uitavanje bitmape iz EXE i BMPFiles eXPress++ komanda

 BMP1 := dc_getbitmap(101)
 BMP2 := dc_getbitmap(102)
 BMP3 := dc_getbitmap("RACUN.BMP")
 BMP4 := dc_getbitmap("RACUN.GIF")
 BMP5 := dc_getbitmap("RACUN.JPG")
 BMP6 := dc_getbitmap("RACUN.PNG")

//-------------------------- opis korienih komandi

@ 17,2 DCSAY 'DC_GetBitmap(x) * ova komanda daje punu transparenciju:'                  SAYSIZE 0
@ 18,2 DCSAY 'x = 101,      102,   "racun.bmp", "racun.gif", "racun.jpg", "racun.png"'  SAYSIZE 0
                                                                           *
//-------------------------- prikaz rezultata

@ 19,2  DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP1
@ 19,12 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP2
@ 19,22 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP3
@ 19,32 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP4
@ 19,42 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP5
@ 19,52 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP6

@ 22,2  DCPUSHBUTTON CAPTION BMP1 SIZE 6,2.5
@ 22,12 DCPUSHBUTTON CAPTION BMP2 SIZE 6,2.5
@ 22,22 DCPUSHBUTTON CAPTION BMP3 SIZE 6,2.5
@ 22,32 DCPUSHBUTTON CAPTION BMP4 SIZE 6,2.5
@ 22,42 DCPUSHBUTTON CAPTION BMP5 SIZE 6,2.5
@ 22,52 DCPUSHBUTTON CAPTION BMP6 SIZE 6,2.5

//-------------------------- uitavanje bitmape iz DLL

 BMP7 := XbpBitmap():new():create()
 BMP7:Load("TEST.DLL",10002)       // uitava se iz DLL ali bitmapa nije transparentna !

 BMP8 := dc_getbitmap(10002)       // ne moe da se uita iz DLL direktnim pozivom ID broja

 BMP9 := dc_getbitmap(DLLPICTURE)  // ne moe da se uita iz DLL ni preko ID broja iz CH fajla

//-------------------------- opis korienih komandi

@ 25,2 DCSAY '1. oBMP:=XbpBitmap():new():create(); oBMP:Load("test.dll",10000)' SAYSIZE 0
@ 26,2 DCSAY "2. oBMP := DC_GetBitmap(10002) iz test.dll fajla direktno "       SAYSIZE 0
@ 27,2 DCSAY "3. oBMP := DC_GetBitmap(DLLPICTURE) iz test.dll preko test.ch"    SAYSIZE 0
@ 28,2 DCSAY "  1                  2                 3"

//-------------------------- prikaz rezultata

@ 29,2  DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP7
 @ 29,12 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP8  COLOR GRA_CLR_WHITE, GRA_CLR_WHITE
 @ 29,22 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 6,2.5 CAPTION BMP9  COLOR GRA_CLR_WHITE, GRA_CLR_WHITE

@ 32,2  DCPUSHBUTTON CAPTION BMP7 SIZE 6,2.5
 @ 32,12 DCPUSHBUTTON CAPTION "NIL" SIZE 6,2.5
 @ 32,22 DCPUSHBUTTON CAPTION "NIL" SIZE 6,2.5

//-------------------------- command buttons

@ 33,42 DCPUSHBUTTON CAPTION BMP7   SIZE 6,2.5 CURSOR {"USER32.DLL",114} ;
                                    TOOLTIP "ORIGINAL FILE:;RACUN.BMP;RACUN.GIF;RACUN.JPG;RACUN.PNG"
@ 33,52 DCPUSHBUTTON CAPTION "Help" SIZE 6,2.5 ACTION {|| chelp() }

//-------------------------- kraj

   DCGETOPTIONS AUTORESIZE SAYFONT "8.Verdana"
   DCREAD GUI TITLE "Xbase++ eXPress++ prikaz transparentnih BMP" OPTIONS GetOptions FIT

RETURN





***********************
FUNCTION chelp()
***********************
LOCAL txt := "uputstvo.txt"
DELETE FILE (txt)
SET CONSOLE OFF
TEXT TO FILE (txt)

COBA Systems Software
BAST Business Account Software Technology
OPEN SOURCE PROJECT
www.cobasystems.com

KAKO KORISTITI BMP RESURSE U APLIKACIJI KAO TRANSPARENTNE BITMAPE
-----------------------------------------------------------------

Bitmape se od strane aplikacije mogu koristiti sa tri lokacije:
iz EXE i iz DLL fajla aplikacije i direktno iz fajla bitmape.

1. Fajl bitmape, na primer RACUN.BMP, se spakuje preko ARC fajla
   u RES fajl pa zatim u EXE fajl aplikacije ili u DLL fajl podrke
   za aplikaciju (deo programa aplikacije).

   U ARC fajl, odnosno u RES fajl pa u EXE ili DLL fajl aplikacije,
   mogu se spakovati samo BMP fajlovi, a ne mogu GIF, JPG i PNG.

2. Bitmape se od strane aplikacije koriste direktno sa diska,
   odnosno iz nekog foldera na disku u koji su spakovane kao
   fajlovi na primer: RACUN.BMP, RACUN.GIF, RACUN.JPG, RACUN.PNG

   Na ovaj nain mogu se koristiti sva etiri formata bitmapa.


U ARC fajl mogu se ukljuiti BMP svejedno da li su INDEKSNE ili RGB
odnosno 16 bitne, 24 bitne ili 32 bitne.




KAKO SE U ARC FAJL I U EXE I DLL PROGRAM - APLIKACIJU UKLJUUJE BMP
-------------------------------------------------------------------

Kao bmp koristi se fajl: RACUN.BMP 16 bitni 32x32 piksela dobijen
konvertovanjem fajla RACUN.ICO u RACUN.BMP iz programa za konverziju
ime se sve transparentne povrine tog ICO fajla pretvore u BMP fajlu
u RGB boju 199,199,199

Formiraju se script fajlovi za ugradnju resursa u EXE i DLL:

   * TEST1.CH                    // Heder script fajl za EXE i DLL

     #define EXEPICTURE 101
     #define DLLPICTURE 10001

   * END TEST1.CH


   * TEST1.ARC                    // Resursi za EXE fajl

     #include "TEST1.CH"
     BITMAP   102 = "RACUN.BMP"   // resurs bez upisa u CH
     BITMAP
     BMPPICTURE   = "RACUN.BMP"   // resurs sa upisom u CH

   * END TEST1.ARC


   * TEST2.ARC                    // Resursi za DLL fajl

     #include "TEST1.CH"
     BITMAP 10002 = "RACUN.BMP"   // resurs bez upisa u CH
     BITMAP
     DLLPICTURE   = "RACUN.BMP"   // resurs sa upisom u CH

   * END TEST2.ARC


Generie se resurs fajl TEST1.RES komandom:
ARC.EXE TEST1.ARC
Generie se resurs fajl TEST2.RES komandom:
ARC.EXE TEST2.ARC


Formira se PROJEKTNI fajl PROJECT.XPJ
za generisanje fajla TEST.EXE - fajla aplikacije:

   * PROJECT.XPJ

     [PROJECT]
         COMPILE       = xpp
         COMPILE_FLAGS = /q
         DEBUG         = no
         GUI           = yes
         LINKER        = alink
         LINK_FLAGS    =
         RC_COMPILE    = arc
         RC_FLAGS      = /v
         OBJ_DIR       = _______OBJ
         PROJECT.XPJ
     [PROJECT.XPJ]
         TEST.EXE
     [TEST.EXE]
     // $START-AUTODEPEND
         TEST.OBJ
     // $STOP-AUTODEPEND
         DCLIPX.LIB              // eXpress++
         TEST1.RES
         TEST.PRG

   * END PROJECT.XPJ


Formira se PROJEKTNI fajl PROJECT_DLL.XPJ
za generisanje fajla TEST.DLL - fajla aplikacije:

   * PROJECT_DLL.XPJ

     [PROJECT]
         COMPILE       = xpp
         // COMPILE_FLAGS = -q -dll:DYNAMIC
         DEBUG         = no
         GUI           = yes
         LINKER        = alink
         LINK_FLAGS    =
         RC_COMPILE    = arc
         RC_FLAGS      = /v
         OBJ_DIR       = _______OBJ
         PROJECT_DLL.XPJ
     [PROJECT_DLL.XPJ]
         TEST.DLL
     [TEST.DLL]
     // $START-AUTODEPEND
     // $STOP-AUTODEPEND
         COMPILE_FLAGS = -q -dll:DYNAMIC
         TEST2.RES

   * END PROJECT_DLL.XPJ


Startom (buildovanjem) projektnog fajla PROJECT.XPJ komandom:
PBUILD.EXE PROJECT.XPJ
dobija se izvrni fajl - aplikacija TEST.EXE

Startom (buildovanjem) projektnog fajla PROJECT_DLL.XPJ komandom:
PBUILD.EXE PROJECT_DLL.XPJ
dobija se pomoni fajl aplikacije TEST.DLL


Ovog momenta imamo aplikaciju TEST.EXE koja sadri dva resursa

 Resurs sa brojem = EXEPICTURE ili 101
 Resurs sa brojem = 102

i imamo kontejner resursa fajl TEST.DLL koji sadri dva resursa

 Resurs sa brojem = DLLPICTURE ili 10001
 Resurs sa brojem = 10002

U ovom primeru, a zbog testiranja programa, sva etiri resursa su
isti fajl RACUN.BMP.


Sada treba proveriti kako sve aplikacija moe da koristi postojee
resurse. U tu svrhu napisan je program TEST.PRG koji iz resursa vri
pozivanje i upotrebu bitmape RACUN.BMP na vie razliitih naina
koristei za to Xbase++ i eXPress++ komande.


REZULTAT TESTIRANJA
-------------------

Izvrenjem aplikacije TEST.EXE vizuelno se prikazuju rezultati razliitih
poziva i upotreba bitmape ugraene u aplikaciju EXE i DLL i bitmape koja
je kao fajl na disku raunara. Rezultat testiranja je sledei:


1.  Bitmapa RACUN.BMP uitana iz TEST.EXE fajla preko TEST1.CH heder fajla,
    kao Numerik i primenjena kao Numerik: EXEPICTURE ili 101
    transparentna je sa eXPress komandama za prikaz bitmape na panelu i na
    dugmetu ako se pre prikaza bitmape na panelu ili na dugmetu postavi komanda:
    aColor := { 192, 192, 192 } // RGB boja koja se prevodi u transparentnu
    DC_BitmapTransparentColor( aColor )
    @ 14,2  DCPUSHBUTTON CAPTION EXEPICTURE SIZE 6,2.5
    ili
    @ 14,2  DCPUSHBUTTON CAPTION 101 SIZE 6,2.5
    ili
    @ 14,2  DCPUSHBUTTON CAPTION dc_getbitmap(101) SIZE 6,2.5

    NAPOMENA:
    Program TEST.EXE ne moe iz TEST.DLL fajla a preko TEST1.CH heder fajla uitati
    bitmapu RACUN.BMP kao Numerik: DLLPICTURE ili 10001


2.  Bitmapa RACUN.BMP uitana iz EXE fajla eXPress++ komandom dc_getbitmap(102)
    kao Objekat i primenjena kao Objekat: oBMP
    transparentna je sa eXPress komandama za prikaz bitmape na panelu i na
    dugmetu ako se pre prikaza bitmape na panelu ili na dugmetu postavi komanda:
    aColor := { 192, 192, 192 } // RGB boja koja se prevodi u transparentnu
    DC_BitmapTransparentColor( aColor )
    oBMP := dc_getbitmap(102)
    @ 14,2  DCPUSHBUTTON CAPTION oBMP SIZE 6,2.5

    NAPOMENA:
    Program TEST.EXE ne moe iz TEST.DLL fajla komandom dc_getbitmap(10002) uitati
    bitmapu RACUN.BMP kao Objekat: oBMP


3.  Bitmapa RACUN.BMP uitana iz EXE ili iz DLL fajla Xbase++ komandom
    kao Objekat i primenjena kao Objekat: oBMP
    nije transparentna sa eXPress komandama za prikaz bitmape na panelu i na
    dugmetu ali se moe bez problema prikazati kao netrasparentna:
    aColor := { 192, 192, 192 } // RGB boja koja se prevodi u transparentnu
    DC_BitmapTransparentColor( aColor )
      oBMP := XbpBitmap():new():create()
      oBMP:Load(NIL,102)            // uitavanje iz EXE fajla
      oBMP:Load("TEST.DLL",10002)   // uitavanje iz DLL fajla
    @ 14,2  DCPUSHBUTTON CAPTION oBMP SIZE 6,2.5
    U ovom sluaju bespotrebna je komanda: DC_BitmapTransparentColor( aColor )


4.  Bitmapa RACUN.BMP, RACUN.GIF, RACUN.JPG, RACUN.PNG uitana kao fajl sa diska
    raunara Xbase++ komandom kao Objekat i primenjena kao Objekat: oBMP
    transparentna je sa eXPress komandama za prikaz bitmape na panelu i na
    dugmetu (osim JPG fajla koji nije transparentan):
    aColor := { 192, 192, 192 } // RGB boja koja se prevodi u transparentnu
    DC_BitmapTransparentColor( aColor )
      oBMP := XbpBitmap():new():create()
      oBMP:LoadFile("RACUN.BMP") // transparentno
      oBMP:LoadFile("RACUN.GIF") // transparentno
      oBMP:LoadFile("RACUN.JPG") // nije transparentno
      oBMP:LoadFile("RACUN.PNG") // transparentno
    @ 14,2  DCPUSHBUTTON CAPTION oBMP SIZE 6,2.5
    Bez komande DC_BitmapTransparentColor( aColor ) svi objekti oBMP se prikazuju
    kao netransparentni na panelu i na dugmetu, a to je sluaj i sa takom 1,2 i 3.

----------
ZAKLJUAK:
----------
U verziji Xbase++ 1.7 i eXPress++ 1.7 da bi se koristile transparentne bitmape na
panelu ili na dugmetu u aplikaciji, one moraju biti u RES odnosno u EXE fajlu
aplikacije i moraju biti BMP formata. Ili moraju biti fajlovi na disku raunara
pa u tom sluaju mogu biti BMP, GIF i PNG formata.
Ne mogu se koristiti kao transparentne BMP koje su u DLL fajlu, osim ako se ne napie
sopstvena procedura upotrebom Windows API funkcija ili C API funkcija.


ENDTEXT
SET CONSOLE ON
q := RunShell("uputstvo.txt","NOTEPAD.EXE")
RETURN NIL






